#include <vmlifters.hpp>

namespace vm::lifters
{
    vm::lifters::lifter_t addq = {
        // vsp[0] = vsp[1] + vsp[0];
        vm::handler::ADDQ, []( vtil::basic_block *blk, vm::instrs::virt_instr_t *vinstr, vmp2::v3::code_block_t* code_blk ) {
            auto [ t0, t1 ] = blk->tmp( 64, 64 );
            blk->pop( t0 );
            blk->pop( t1 );
            blk->add( t1, t0 );
            blk->push( t1 );
            blk->pushf();
        } };

    vm::lifters::lifter_t adddw = {
        // vsp[0] = vsp[1] + vsp[0];
        vm::handler::ADDDW, []( vtil::basic_block *blk, vm::instrs::virt_instr_t *vinstr, vmp2::v3::code_block_t* code_blk ) {
            auto [ t0, t1 ] = blk->tmp( 32, 32 );
            blk->pop( t0 );
            blk->pop( t1 );
            blk->add( t1, t0 );
            blk->push( t1 );
            blk->pushf();
        } };

    vm::lifters::lifter_t addw = {
        // vsp[0] = vsp[1] + vsp[0];
        vm::handler::ADDW, []( vtil::basic_block *blk, vm::instrs::virt_instr_t *vinstr, vmp2::v3::code_block_t* code_blk ) {
            auto [ t0, t1 ] = blk->tmp( 16, 16 );
            blk->pop( t0 );
            blk->pop( t1 );
            blk->add( t1, t0 );
            blk->push( t1 );
            blk->pushf();
        } };
} // namespace vm::lifters