#include <vmlifters.hpp>

namespace vm::lifters
{
    vm::lifters::lifter_t sregq = {
        // pop vregX
        vm::handler::SREGQ,
        []( vtil::basic_block *blk, vm::instrs::virt_instr_t *vinstr, vmp2::v3::code_block_t *code_blk ) {
            blk->pop( make_virtual_register( vinstr->operand.imm.u, 8 ) );
        } };

    vm::lifters::lifter_t sregdw = {
        // pop vregX
        vm::handler::SREGDW,
        []( vtil::basic_block *blk, vm::instrs::virt_instr_t *vinstr, vmp2::v3::code_block_t *code_blk ) {
            blk->pop( make_virtual_register( vinstr->operand.imm.u, 4 ) );
        } };

    vm::lifters::lifter_t sregw = {
        // pop vregX
        vm::handler::SREGW,
        []( vtil::basic_block *blk, vm::instrs::virt_instr_t *vinstr, vmp2::v3::code_block_t *code_blk ) {
            blk->pop( make_virtual_register( vinstr->operand.imm.u, 2 ) );
        } };
} // namespace vm::lifters